<?php
/*
Plugin Name: WP-kitajiro-syntax
Plugin URI: http://www.karak.jp/
Description: 北辞郎記法を利用するためのプラグイン。 {{}} で囲んだ部分を簡体字中国語用のspanタグで括り、[[]]で囲んだ単語に北辞郎へのリンクを設定する。
Version: 1.0
Author: Shinsuke Takeuchi
Author URI: http://www.karak.jp/
*/

function kj_syntax_replace($content) {
	$content = preg_replace('/\{\{([^\}]+)\}\}/u', '<span lang="zh" xml:lang="zh" class="kjcn">\1</span>', $content);
	$content = preg_replace_callback("/\[\[([^\]]+)\]\]/u", "generate_link_url", $content);
	$content = str_replace("\\[", "[", $content);
	$content = str_replace("\\{", "{", $content);
	return $content;
}

function generate_link_url($matches) {
	$enc = urlencode($matches[1]);
	$link = '<a lang="zh" xml:lang="zh" class="kjcn" href="http://www.ctrans.org/search.php?word=' . $enc . '&opts=ex">' . $matches[1] . '</a>';
	return $link;
}

function apply_style_sheet(){
	$plugin_dir = str_replace(basename(__FILE__),"",plugin_basename(__FILE__));
	$css_url = WP_PLUGIN_URL.'/'.$plugin_dir.'css/kj.css';
	wp_enqueue_style( 'kj-style-sheet', $css_url, false, 'g1' );
}

add_action('wp_print_styles','apply_style_sheet');
add_filter('the_content','kj_syntax_replace');

?>